#ifndef _CCACHE_H
#define _CCACHE_H 1

#include "wordlist.h"
#include "FL/Fl_Node.H"
#include "mailbox.h"
#include "btree.h"

char *stripre (char *);

class CCacheNode : public BTreeNode
{
	public:
						 CCacheNode (const char *, CCacheNode *N = NULL, MailMessage *M = NULL, Fl_Node *No = NULL);
						~CCacheNode (void);

       	MailMessage		*msg;
		Fl_Node			*node;
};

class CCache
{
	public:
						 CCache (void);
						~CCache (void);

		void			 Add (MailMessage *, Fl_Node *);
		CCacheNode		*FindMsgid (char *);
		CCacheNode		*FindMsgid (WordList *);
		CCacheNode		*FindSubject (char *);
		CCacheNode		*FindNode (Fl_Node *);
		void			 Clear (void);

	private:
		CCacheNode		*MsgRoot, *SubjRoot;
};

#endif
