#include <string.h>
#include <sys/types.h>

//===============================================================================
// FUNCTION		checksum
// SYNOPSIS		Turns a string into a rough hash-index.
//
// ARGUMENTS	string		(char *)	The string to be checksumed
//
// RETURNS		The checksum value.
//===============================================================================

u_long checksum (char *string)
{
	register char   c;
	register int    len, pos;
	register u_long result, max,mult;

	result = 0;
	len = strlen (string);
	max = (8*len*32);
	mult = (0x80000000 / (max+1));
	
	for (pos = 0; pos < len; ++pos)
	{
		c = string[pos];
		if ((c >= '0') && (c <= '9'))
			result += 2 ^ (c - '0' + 1);
		else
			result += ((pos & 0x0f) * (c & 31));
	}
	result = result * mult;
	return result;
}

