#include <string.h>
#include <stdio.h>
#include <ctype.h>

#include "encode.h"

inline int needsescape (char x)
{
	char y;
	
	if (x<32) return 1;
	if ( (x=='.') || (x==',') || (x==':') || (x==';') || (x=='/') || (x=='!') || (x=='?')) return 0;
	y = tolower (x);
	
	if (y>='a' && y<='z') return 0;
	if (y>='0' && y<='9') return 0;
	if (y==' ') return 0;
	return 1;
}

const char *hexadeci = "0123456789abcdef";

char *encode_mysql (char *input)
{
	int   tlen = 0;
	char *crsr;
	char *result;
	int   pos;
	
	crsr = input;
	while ( (crsr) && (*crsr) )
	{
		++tlen;
		if (needsescape (*crsr)) tlen +=2;
		++crsr;
	}
	
	result = new char[tlen+24];
	
	crsr = input;
	pos  = 0;
	
	while ( (crsr) && (*crsr) )
	{
		printf ("encoding: %04i\r", pos);
		if (needsescape (*crsr))
		{
			result[pos++] = '@';
			result[pos++] = hexadeci[(((*crsr) & 0xf0) >> 4)];
			result[pos++] = hexadeci[((*crsr) & 0x0f)];
		}
		else
		{
			result[pos++] = *crsr;
		}
		++crsr;
	}
	result[pos] = 0;
	
	return (result);
}

char *decode_mysql (char *input)
{
	char *result;
	char *crsr;
	int   tlen = 0;
	int   pos  = 0;
	
	int   digit1, digit2;

	crsr = input;
		
	while ( (crsr) && (*crsr) )
	{
		if (*crsr == '@')
		{
			if ( (*(crsr+1)) && (*(crsr+2)) ) crsr +=2;
		}
		++crsr;
		++tlen;
	}
	
	result = new char[tlen+2];
	
	crsr = input;
		
	while ( (crsr) && (*crsr) )
	{
		if (*crsr == '@')
		{
			if ( (*(crsr+1)) && (*(crsr+2)) )
			{
				digit1 = *(crsr+1);
				if ( (digit1 >= '0') && (digit1 <= '9') ) digit1 = digit1 - '0';
				else if ( (digit1 >='a') && (digit1 <='f') ) digit1 = 10 + digit1 - 'a';
				else digit1 = -1;
				
				digit2 = *(crsr+2);
				if ( (digit2 >= '0') && (digit2 <= '9') ) digit2 = digit2 - '0';
				else if ( (digit2 >='a') && (digit2 <='f') ) digit2 = 10 + digit2 - 'a';
				else digit2 = -1;
				
				if ((digit1 < 0) || (digit2 < 0)) result[pos++] = ' ';
				else result[pos++] = ( (digit1 & 0x0f) << 4) + (digit2 & 0x0f);
				++crsr;
				++crsr;
			}
		}
		else
		{
			result[pos++] = *crsr;
		}
		++crsr;
	}
	result[pos] = 0;
	
	return (result);
}

WordList *extract_lines (char *message)
{
	WordList *result = new WordList;
	result->MakeGeneric (message, '\n');
	return (result);
}

