#include "helpdesk.h"
#include <FL/Fl_Pixmap.H>

static unsigned char *image_folder[] = {
(unsigned char *)"16 16 11 1",
(unsigned char *)"g c #808080",
(unsigned char *)"# c #a0a0a0",
(unsigned char *)"c c #c3c3c3",
(unsigned char *)"h c #c0c000",
(unsigned char *)"i c #000000",
(unsigned char *)"b c #ffff00",
(unsigned char *)"a c #ffffc0",
(unsigned char *)". c None",
(unsigned char *)"e c #585858",
(unsigned char *)"f c #dcdcdc",
(unsigned char *)"d c #ffffff",
(unsigned char *)"................",
(unsigned char *)"................",
(unsigned char *)"...######.......",
(unsigned char *)"..#ababa##......",
(unsigned char *)".#abababac#####.",
(unsigned char *)".#dadadadadddd#e",
(unsigned char *)".#dbfbfbfbfbfb#e",
(unsigned char *)".#dfbfbfbfbfbf#e",
(unsigned char *)".#dbfbfbfbfbfb#e",
(unsigned char *)".#dfbfbfbfbfbf#e",
(unsigned char *)".#dbfbfbfbfbfb#e",
(unsigned char *)".#dfbfbfbfbfbf#e",
(unsigned char *)".#dbfbfbfbfbfb#e",
(unsigned char *)".ghhhhhhhhhhhh#e",
(unsigned char *)"..iiiiiiiiiiiiii",
(unsigned char *)"................"
};
Fl_Pixmap pixmap_folder(image_folder);

/* XPM */
static unsigned char *image_identity[] = {
(unsigned char *) "16 16 81 1",
(unsigned char *) " 	c None",
(unsigned char *) ".	c #4E6767",
(unsigned char *) "+	c #3A4D4D",
(unsigned char *) "@	c #A1D3D0",
(unsigned char *) "#	c #C8F2D8",
(unsigned char *) "$	c #CDC471",
(unsigned char *) "%	c #A18F46",
(unsigned char *) "&	c #322C17",
(unsigned char *) "*	c #95C5C4",
(unsigned char *) "=	c #CEE9BC",
(unsigned char *) "-	c #DBD681",
(unsigned char *) ";	c #D1B851",
(unsigned char *) ">	c #A7954C",
(unsigned char *) ",	c #80723B",
(unsigned char *) "'	c #99BFB1",
(unsigned char *) ")	c #D4E1A2",
(unsigned char *) "!	c #D5BA52",
(unsigned char *) "~	c #A4924B",
(unsigned char *) "{	c #A5934C",
(unsigned char *) "]	c #1A1709",
(unsigned char *) "^	c #685B26",
(unsigned char *) "/	c #807A44",
(unsigned char *) "(	c #A89748",
(unsigned char *) "_	c #A9964C",
(unsigned char *) ":	c #7E713A",
(unsigned char *) "<	c #282412",
(unsigned char *) "[	c #5C6752",
(unsigned char *) "}	c #D5DF9B",
(unsigned char *) "|	c #D1BC57",
(unsigned char *) "1	c #7A6C32",
(unsigned char *) "2	c #453D1F",
(unsigned char *) "3	c #433B1E",
(unsigned char *) "4	c #5E5227",
(unsigned char *) "5	c #5B5129",
(unsigned char *) "6	c #46443C",
(unsigned char *) "7	c #655825",
(unsigned char *) "8	c #DED171",
(unsigned char *) "9	c #D2E4AB",
(unsigned char *) "0	c #D5DF9D",
(unsigned char *) "a	c #D2B851",
(unsigned char *) "b	c #C3AC4F",
(unsigned char *) "c	c #DDC153",
(unsigned char *) "d	c #C3AB4C",
(unsigned char *) "e	c #231F10",
(unsigned char *) "f	c #E5C754",
(unsigned char *) "g	c #E4C958",
(unsigned char *) "h	c #DED170",
(unsigned char *) "i	c #CFE8B9",
(unsigned char *) "j	c #DAD886",
(unsigned char *) "k	c #D2BB57",
(unsigned char *) "l	c #B49F4D",
(unsigned char *) "m	c #A7944C",
(unsigned char *) "n	c #494121",
(unsigned char *) "o	c #625624",
(unsigned char *) "p	c #E4C753",
(unsigned char *) "q	c #E4C754",
(unsigned char *) "r	c #E5C854",
(unsigned char *) "s	c #AA9A52",
(unsigned char *) "t	c #928036",
(unsigned char *) "u	c #AC984C",
(unsigned char *) "v	c #4C421C",
(unsigned char *) "w	c #988846",
(unsigned char *) "x	c #63582D",
(unsigned char *) "y	c #050402",
(unsigned char *) "z	c #746630",
(unsigned char *) "A	c #756835",
(unsigned char *) "B	c #4F4624",
(unsigned char *) "C	c #E5C753",
(unsigned char *) "D	c #84753C",
(unsigned char *) "E	c #746735",
(unsigned char *) "F	c #363019",
(unsigned char *) "G	c #302911",
(unsigned char *) "H	c #C4AC4B",
(unsigned char *) "I	c #978645",
(unsigned char *) "J	c #221E0F",
(unsigned char *) "K	c #1F1C0D",
(unsigned char *) "L	c #786A31",
(unsigned char *) "M	c #CBB24C",
(unsigned char *) "N	c #655A2E",
(unsigned char *) "O	c #1C190D",
(unsigned char *) "P	c #252111",
(unsigned char *) "                ",
(unsigned char *) "       ..       ",
(unsigned char *) "     +@#$%&     ",
(unsigned char *) "     *=-;>,     ",
(unsigned char *) "     ')!~{,     ",
(unsigned char *) "   ]^/(_~:<     ",
(unsigned char *) "   [}|123456    ",
(unsigned char *) "   7890abbcde   ",
(unsigned char *) "   7fghijklmn   ",
(unsigned char *) "   etprppu{{n   ",
(unsigned char *) "    vqfppuwxy   ",
(unsigned char *) "    vqrpzAB<    ",
(unsigned char *) "    vCrpDE{F    ",
(unsigned char *) "    GHfp~{IJ    ",
(unsigned char *) "     KLMINO     ",
(unsigned char *) "       PP       "};

Fl_Pixmap pixmap_identity(image_identity);


static unsigned char *image_folder_open[] = {
(unsigned char *)"16 16 17 1",
(unsigned char *)"a c #808080",
(unsigned char *)"m c #f7f7e7",
(unsigned char *)"c c #94968c",
(unsigned char *)"n c #efeb31",
(unsigned char *)"i c #c6c75a",
(unsigned char *)"j c #4a4d39",
(unsigned char *)"h c #e7e752",
(unsigned char *)"k c #c6c38c",
(unsigned char *)"o c #000000",
(unsigned char *)"# c #cecfce",
(unsigned char *)"f c #efebd6",
(unsigned char *)"b c #bdbab5",
(unsigned char *)"g c #6b6d6b",
(unsigned char *)"e c #efefa5",
(unsigned char *)". c None",
(unsigned char *)"d c #efefef",
(unsigned char *)"l c #ffffff",
(unsigned char *)"................",
(unsigned char *)"................",
(unsigned char *)"...#aaaa........",
(unsigned char *)"..#abbbbc.......",
(unsigned char *)".#adefefbcaaaaa.",
(unsigned char *)".gdehhhhfbbbbbca",
(unsigned char *)".gdhihhhhfffffbj",
(unsigned char *)"#g#bikikikikiicj",
(unsigned char *)"gcccccccccccgiij",
(unsigned char *)"gldfdfmfmmmkjgcj",
(unsigned char *)"gd#nknknkhhhjjgj",
(unsigned char *)".gdknknknkhhcjjj",
(unsigned char *)".gdnknknknihhjjj",
(unsigned char *)"..gdnknknknkhijo",
(unsigned char *)"..ggggggggggggjo",
(unsigned char *)"...ooooooooooooo",
};
Fl_Pixmap pixmap_folder_open(image_folder_open);

static unsigned char *image_mbox[]={
(unsigned char *)"15 13 4 1",
(unsigned char *)" 	c None",
(unsigned char *)".	c white",
(unsigned char *)"X	c #c0c0c0",
(unsigned char *)"o	c #808080",
(unsigned char *)"               ",
(unsigned char *)"      .........",
(unsigned char *)"     .XXXXXXXX.",
(unsigned char *)"    ..........o",
(unsigned char *)"   .XXXXXXX..o.",
(unsigned char *)"  ..........o.o",
(unsigned char *)" .XXXXXXX..o.o.",
(unsigned char *)"..........o.o.o",
(unsigned char *)"oooooooooo.o.o ",
(unsigned char *)"..........o.o  ",
(unsigned char *)"oooooooooo.o   ",
(unsigned char *)"..........o    ",
(unsigned char *)"oooooooooo     "
};
Fl_Pixmap pixmap_mbox(image_mbox);
