#include <time.h>
#include "semaphore.h"
#include "helpdesk.h"
#include "var.h"
#include "mailbox.h"
#include <FL/Fl_Pixmap.H>
#include <FL/Fl_Multi_Browser.H>

extern ITCPipe		 *PIPE;
extern Fl_Scroll	 *current_boxlist;

extern Fl_Pixmap	  pixmap_folder;
extern Fl_Pixmap	  pixmap_folder_open;
extern Fl_Pixmap	  pixmap_mbox;
extern Fl_Pixmap	  pixmap_identity;
extern ITCPipe		 *PIPE;

static unsigned char *image_radio_off[] = {
(unsigned char *)"16 16 17 1",
(unsigned char *)" \tc None",
(unsigned char *)".\tc #626062",
(unsigned char *)"+\tc #0C0C0C",
(unsigned char *)"@\tc #050505",
(unsigned char *)"#\tc #1B1B1B",
(unsigned char *)"$\tc #3F3E3F",
(unsigned char *)"%\tc #9D9E9D",
(unsigned char *)"&\tc #B8B9B8",
(unsigned char *)"*\tc #AAABAA",
(unsigned char *)"=\tc #545454",
(unsigned char *)"-\tc #CFCFCF",
(unsigned char *)";\tc #DDDDDD",
(unsigned char *)">\tc #888888",
(unsigned char *)",\tc #8F908F",
(unsigned char *)"\'\tc #302F30",
(unsigned char *)")\tc #777977",
(unsigned char *)"!\tc #474547",
(unsigned char *)"                ",
(unsigned char *)"                ",
(unsigned char *)"      .+@#      ",
(unsigned char *)"    $#%&&*=@    ",
(unsigned char *)"   $=&-;;;->@   ",
(unsigned char *)"   .,-;;;;-*$   ",
(unsigned char *)"  .>-;;;---*>\'  ",
(unsigned char *)"  \');;;---*%>@  ",
(unsigned char *)"  \');;--&*%%>@  ",
(unsigned char *)"  .);;-&*%,,)$  ",
(unsigned char *)"   .,-&*%,,>\'   ",
(unsigned char *)"   !$,%%,,))@   ",
(unsigned char *)"    $\'...)!@    ",
(unsigned char *)"      )+@\'      ",
(unsigned char *)"                ",
(unsigned char *)"                "
};
static Fl_Pixmap pixmap_radio_off(image_radio_off);

static unsigned char *image_radio_on[] = {
(unsigned char *)"16 16 17 1",
(unsigned char *)" \tc None",
(unsigned char *)".\tc #9C9D9C",
(unsigned char *)"+\tc #525052",
(unsigned char *)"@\tc #626162",
(unsigned char *)"#\tc #A4A5A4",
(unsigned char *)"$\tc #393839",
(unsigned char *)"%\tc #101010",
(unsigned char *)"&\tc #737173",
(unsigned char *)"*\tc #4A484A",
(unsigned char *)"=\tc #8B8D8B",
(unsigned char *)"-\tc #202020",
(unsigned char *)";\tc #B4B6B4",
(unsigned char *)">\tc #080808",
(unsigned char *)",\tc #C5C6C5",
(unsigned char *)"\'\tc #EEEEEE",
(unsigned char *)")\tc #FFFFFF",
(unsigned char *)"!\tc #D5D6D5",
(unsigned char *)"                ",
(unsigned char *)"                ",
(unsigned char *)"      .++@      ",
(unsigned char *)"    #@$%%%&*    ",
(unsigned char *)"   #$%+&&=@+*   ",
(unsigned char *)"   *-&*---.;%   ",
(unsigned char *)"  #$+*>>>>%=.=  ",
(unsigned char *)"  *-&->>>>>.,>  ",
(unsigned char *)"  *-&->>>>>.\'>  ",
(unsigned char *)"  *-=->>>>>#)-  ",
(unsigned char *)"   +@=%>>>&)=   ",
(unsigned char *)"   *@;&==.\')>   ",
(unsigned char *)"    +-#!\')&>    ",
(unsigned char *)"      &%>$      ",
(unsigned char *)"                ",
(unsigned char *)"                "
};
static Fl_Pixmap pixmap_radio_on(image_radio_on);

extern Var PREFERENCES;
Var LPREFERENCES;
extern MailBox *MailBoxList[16];

extern void update_tree (Fl_Scroll *);

Var *PREFS_CURRENTBOX = (Var *) NULL;
Var *PREFS_CURRENTIDENT = (Var *) NULL;
Var *PREFS_FCURRENTBOX = (Var *) NULL;

//extern Fl_Pixmap pixmap_radio_on;
//extern Fl_Pixmap pixmap_radio_off;

void func_view_protocol (void)
{
	int val = ch_prefs_protocol->value();
	
	switch (val)
	{
		case 0:
			gr_prefs_protocol_mysql->show();
			gr_prefs_protocol_pop3->hide();
			gr_prefs_protocol_nntp->hide();
			if (PREFS_CURRENTBOX)
			{
				PREFS_CURRENTBOX->Set_char ("protocol","mysql");
				in_prefs_protocol_mysql_host->value (PREFS_CURRENTBOX->Get_char ("host"));
				in_prefs_protocol_mysql_user->value (PREFS_CURRENTBOX->Get_char ("user"));
				in_prefs_protocol_mysql_pass->value (PREFS_CURRENTBOX->Get_char ("pass"));
				in_prefs_protocol_mysql_db->value    (PREFS_CURRENTBOX->Get_char ("database"));
				in_prefs_protocol_mysql_tab->value   (PREFS_CURRENTBOX->Get_char ("table"));
			}
			break;

		case 1:
			gr_prefs_protocol_mysql->hide();
			gr_prefs_protocol_pop3->show();
			gr_prefs_protocol_nntp->hide();
			if (PREFS_CURRENTBOX)
			{
				PREFS_CURRENTBOX->Set_char ("protocol","pop3");
				in_prefs_protocol_pop3_host->value (PREFS_CURRENTBOX->Get_char ("host"));
				in_prefs_protocol_pop3_user->value (PREFS_CURRENTBOX->Get_char ("user"));
				in_prefs_protocol_pop3_pass->value (PREFS_CURRENTBOX->Get_char ("pass"));
			}
			break;

		case 2:
			gr_prefs_protocol_mysql->hide();
			gr_prefs_protocol_pop3->hide();
			gr_prefs_protocol_nntp->show();
			if (PREFS_CURRENTBOX)
			{
				PREFS_CURRENTBOX->Set_char ("protocol","nntp");
				in_prefs_protocol_nntp_host->value (PREFS_CURRENTBOX->Get_char ("host"));
				in_prefs_protocol_nntp_user->value (PREFS_CURRENTBOX->Get_char ("user"));
				in_prefs_protocol_nntp_pass->value (PREFS_CURRENTBOX->Get_char ("pass"));
			}
			break;

		default:
			gr_prefs_protocol_mysql->hide();
			gr_prefs_protocol_pop3->hide();
			gr_prefs_protocol_nntp->hide();
			break;
	}
	if (PREFS_CURRENTBOX)
	{
		int val;
		ch_prefs_collection->value (PREFS_CURRENTBOX->Get_int ("collection"));
		ch_prefs_msgpolicy->value (PREFS_CURRENTBOX->Get_int ("msgpolicy"));
		ch_prefs_rplypolicy->value (PREFS_CURRENTBOX->Get_int ("rplypolicy"));
		ch_prefs_msgarchive->value (PREFS_CURRENTBOX->Get_int ("msgarchive"));
		if (val = PREFS_CURRENTBOX->Get_int ("archtrash"))
		{
			printf ("[setradio] archtrash=%i trash_local(off) trash_server(on)\n", val);
			pixmap_radio_off.label (rd_prefs_trash_local);
			pixmap_radio_on.label (rd_prefs_trash_server);
		}
		else
		{
			printf ("[setradio] archtrash=%i trash_local(on) trash_server(off)\n", val);
			pixmap_radio_on.label (rd_prefs_trash_local);
			pixmap_radio_off.label (rd_prefs_trash_server);
		}
		rd_prefs_trash_local->redraw();
		rd_prefs_trash_server->redraw();
		//ch_prefs_archtrash->value (PREFS_CURRENTBOX->Get_int ("archtrash"));
	}
}

void cb_prefs_trash_server (Fl_Button *b, void *d)
{
	PREFS_CURRENTBOX->Set_int ("archtrash", 1);
	pixmap_radio_off.label (rd_prefs_trash_local);
	pixmap_radio_on.label (rd_prefs_trash_server);
	rd_prefs_trash_local->redraw();
	rd_prefs_trash_server->redraw();
}

void cb_prefs_trash_local (Fl_Button *b, void *d)
{
	PREFS_CURRENTBOX->Set_int ("archtrash", 0);
	pixmap_radio_on.label (rd_prefs_trash_local);
	pixmap_radio_off.label (rd_prefs_trash_server);
	rd_prefs_trash_local->redraw();
	rd_prefs_trash_server->redraw();
}

void cb_configure (Fl_Button *b, void *d)
{
	WordList		*W;
	int			  i;
	
	if (!(win_prefs)) make_prefs_window();
	
	// Display Mailboxes
	
	while (br_prefs_mailboxes->size()) br_prefs_mailboxes->remove (1);
	while (br_prefs_mailfolders_mailboxes->size()) br_prefs_mailfolders_mailboxes->remove (1);
	//br_prefs_mailboxes->clear();
	LPREFERENCES.CopyFrom (&PREFERENCES);
	LPREFERENCES.Save ("localprefs.dump");
	W = LPREFERENCES.Get_collection ("postoffice")->Get_wordlist ("mailboxes");
	for (i=0; i<W->Count; ++i)
	{
		br_prefs_mailboxes->add (W->Get(i), &pixmap_folder, NULL);
		br_prefs_mailfolders_mailboxes->add (W->Get(i), &pixmap_folder, NULL);
	}
	
	// Display Identities
	
	//br_prefs_identities->clear();
	while (br_prefs_identities->size()) br_prefs_identities->remove(1);
	W = LPREFERENCES.Get_collection ("postoffice")->Get_wordlist ("identities");
	for (i=0;i<W->Count;++i)
	{
		br_prefs_identities->add (LPREFERENCES.Get_collection ("postoffice")->Get_collection ("identities")->Get_collection (W->Get(i))->Get_char ("shortname"), &pixmap_identity, NULL );
	}
	in_prefs_smtpserver->value (LPREFERENCES.Get_char_tree ("postoffice/network/smtp"));
	gr_identities_set->deactivate();
	gr_mailboxes_set->deactivate();
	gr_prefs_filters->deactivate();

	br_prefs_mailfolders_folders->deactivate();
	br_prefs_mailfolders_subfolders->deactivate();
	gr_prefs_mailfolders_folderset->deactivate();
	gr_prefs_mailfolders_subset->deactivate();
	bt_prefs_mailfolders_folderadd->deactivate();
	bt_prefs_mailfolders_newsub->deactivate();
	
	tb_prefs->value(gr_prefs_mailboxes);
	cb_prefs_tab (tb_prefs, NULL);
	win_prefs->show();
	ed_prefs_edittexts->ShowPanel (0);
}

void cb_prefs_tab (Fl_Tabs *t, void *v)
{
	Fl_Group *current = (Fl_Group *) tb_prefs->value();
	gr_prefs_mailboxes->color (47);
	gr_prefs_identities->color (47);
	gr_prefs_network->color(47);
	gr_prefs_language->color(47);
	gr_prefs_mailfolders->color(47);
	current->color (51);
}
void cb_prefs_mailboxes (Fl_Iconbrowser *b, void *v)
{
	int val;
	char *proto;
	
	if (val = br_prefs_mailboxes->value())
	{
		gr_mailboxes_set->activate();
		PREFS_CURRENTBOX = LPREFERENCES.Get_collection("postoffice")->Get_collection("mailboxes")->Get_collection (br_prefs_mailboxes->text(val));
		in_prefs_mailboxname->value (br_prefs_mailboxes->text(val));
		
		proto = PREFS_CURRENTBOX->Get_char ("protocol");
		if (strcasecmp (proto, "mysql") == 0)
		{
			ch_prefs_protocol->value (0);
		}
		else if (strcasecmp (proto, "pop3") == 0)
		{
			ch_prefs_protocol->value (1);
		}
		else if (strcasecmp (proto, "nntp") == 0)
		{
			ch_prefs_protocol->value (2);
		}
		else
		{
			ch_prefs_protocol->value(0);
		}
		//ch_prefs_protocol->update();
		func_view_protocol();
	}
	else gr_mailboxes_set->deactivate();
}

void cb_prefs_mailfolders_mailboxes (Fl_Iconbrowser *b, void *v)
{
	int imailbox;
	char *mailbox;
	int i;
	
	while (br_prefs_mailfolders_folders->size()) br_prefs_mailfolders_folders->remove(1);
	while (br_prefs_mailfolders_subfolders->size()) br_prefs_mailfolders_subfolders->remove(1);
	
	imailbox = br_prefs_mailfolders_mailboxes->value();
	if (imailbox)
	{
		mailbox = br_prefs_mailfolders_mailboxes->text (imailbox);
		PREFS_FCURRENTBOX = LPREFERENCES.Get_collection ("postoffice")->Get_collection("mailboxes")->Get_collection ((char *) mailbox);
		WordList *F = PREFS_FCURRENTBOX->Get_wordlist ("folders");
		for (i=0;i<F->Count;++i)
		{
			if (!strchr (F->Get(i), ':'))
			{
				if (strcasecmp (PREFS_FCURRENTBOX->Get_collection ("folders")->Get_collection (F->Get(i))->Get_char ("type"), "sub") == 0)
				{
					br_prefs_mailfolders_folders->add (F->Get(i), &pixmap_folder, NULL);
				}
				else br_prefs_mailfolders_folders->add (F->Get(i), &pixmap_mbox, NULL);
			}
		}
		br_prefs_mailfolders_folders->redraw();
		gr_prefs_mailfolders_folderset->deactivate();
		bt_prefs_mailfolders_folderadd->activate();
		bt_prefs_mailfolders_newsub->activate();
		br_prefs_mailfolders_folders->activate();
		br_prefs_mailfolders_subfolders->deactivate();
		gr_prefs_mailfolders_subset->deactivate();
		bt_prefs_mailfolders_subadd->deactivate();
		gr_prefs_filters->deactivate();
	}
}

int filwidths[2] = {125,0};

void cb_prefs_mailfolders_folders (Fl_Iconbrowser *b, void *v)
{
	int ifolder;
	char *folder;
	WordList W;
	int i;
	char tmp[128];
	
	while (br_prefs_mailfolders_subfolders->size()) br_prefs_mailfolders_subfolders->remove(1);
	ifolder = br_prefs_mailfolders_folders->value();
	if (ifolder)
	{
		folder = br_prefs_mailfolders_folders->text (ifolder);
		in_prefs_mailfolders_foldername->value (folder);
		if (strcasecmp (PREFS_FCURRENTBOX->Get_collection ("folders")->Get_collection (folder)->Get_char ("type"), "sub") == 0)
		{
			WordList *F = PREFS_FCURRENTBOX->Get_wordlist ("folders");
			for (i=0;i<F->Count;++i)
			{
				if (strchr (F->Get(i), ':'))
				{
					W.MakeGeneric (F->Get(i), ':');
					if (strcasecmp (W.Get(0), folder) == 0) br_prefs_mailfolders_subfolders->add (W.Get(1), &pixmap_mbox, NULL);
				}
			}
			gr_prefs_mailfolders_folderset->activate();
			br_prefs_mailfolders_subfolders->activate();
			bt_prefs_mailfolders_subadd->activate();
			gr_prefs_mailfolders_subset->deactivate();
			gr_prefs_filters->deactivate();
			br_prefs_filters->clear();
		}
		else
		{
			gr_prefs_mailfolders_folderset->activate();
			br_prefs_mailfolders_subfolders->deactivate();
			bt_prefs_mailfolders_subadd->deactivate();
			gr_prefs_mailfolders_subset->deactivate();
			gr_prefs_filters->activate();
			br_prefs_filters->clear();
			br_prefs_filters->column_widths (filwidths);
			WordList *WW = PREFS_FCURRENTBOX->Get_collection ("folders")->Get_collection (folder)->Get_wordlist ("filters");
			for (i=0; i+4 < WW->Count; i+=5)
			{
				char *xxx = WW->Get(i);
				if (atoi (xxx)==7) xxx = "Envelope Folder";
				if (atoi (xxx)==2) xxx = "Envelope From";
				sprintf (tmp, "%s\t%s", xxx, WW->Get(i+4));
				br_prefs_filters->add (tmp, NULL);
			}
			bt_prefs_filt_delete->deactivate();
		}
	}
}

void cb_prefs_br_filters (Fl_Browser *b, void *v)
{
	int ifolder;
	char *folder;

	ifolder = br_prefs_mailfolders_folders->value();
	if (ifolder)
	{
		folder = br_prefs_mailfolders_folders->text (ifolder);

		WordList *F = PREFS_FCURRENTBOX->Get_collection ("folders")->Get_collection (folder)->Get_wordlist ("filters");
		int pos = br_prefs_filters->value();
		if (pos)
		{
			bt_prefs_filt_delete->activate();
			pos = 5*(pos-1);
			if (F->GetInt (pos) == 7) ch_prefs_filt_match->value(0);
			else if (F->GetInt (pos) == 2) ch_prefs_filt_match->value(1);
			else if (strcasecmp (F->Get (pos), "Message-ID") == 0) ch_prefs_filt_match->value(2);
			else if (strcasecmp (F->Get (pos), "Subject") == 0) ch_prefs_filt_match->value(3);
			else if (strcasecmp (F->Get (pos), "From") == 0) ch_prefs_filt_match->value(4);
			else if (strcasecmp (F->Get (pos), "To") == 0) ch_prefs_filt_match->value(5);
			else if (strcasecmp (F->Get (pos), "Newsgroups") == 0) ch_prefs_filt_match->value(6);
			else if (strcasecmp (F->Get (pos), "Sender") == 0) ch_prefs_filt_match->value(7);
			else if (strcasecmp (F->Get (pos), "Reply-To") == 0) ch_prefs_filt_match->value(8);
			else if (strcasecmp (F->Get (pos), "Received") == 0) ch_prefs_filt_match->value(9);
			else if (strcasecmp (F->Get (pos), "Cc") == 0) ch_prefs_filt_match->value(10);

			if (strcasecmp (F->Get (pos+1), "subs") == 0) ch_prefs_filt_type->value(0);
			else if (strcasecmp (F->Get (pos+1), "case") == 0) ch_prefs_filt_type->value(1);
			else if (strcasecmp (F->Get (pos+1), "glob") == 0) ch_prefs_filt_type->value(2);

			if (strcasecmp (F->Get (pos+2), "accept") == 0) ch_prefs_filt_action->value(0);
			else if (strcasecmp (F->Get (pos+2), "deny") == 0) ch_prefs_filt_action->value(1);
			else if (strcasecmp (F->Get (pos+2), "score") == 0) ch_prefs_filt_action->value(2);

			in_prefs_filt_string->value (F->Get (pos+4));
		}
	}
}

void cb_prefs_delfilter (Fl_Button *b, void *v)
{
	int ifolder;
	char *folder;
	int i;
	char tmp[128];

	ifolder = br_prefs_mailfolders_folders->value();
	if (ifolder)
	{
		folder = br_prefs_mailfolders_folders->text (ifolder);

		WordList *F = PREFS_FCURRENTBOX->Get_collection ("folders")->Get_collection (folder)->Get_wordlist ("filters");
		int pos = br_prefs_filters->value();
		if (pos)
		{
			bt_prefs_filt_delete->deactivate();
			pos = 5*(pos-1);
			for (i=0;i<5;++i) F->Delete (pos);

			br_prefs_filters->clear();

			for (i=0; i+4 < F->Count; i+=5)
			{
				sprintf (tmp, "%s\t%s", F->Get(i), F->Get(i+4));
				br_prefs_filters->add (tmp, NULL);
			}
		}
	}
}

void cb_prefs_addfilter (Fl_Button *b, void *v)
{
	int ifolder;
	char *folder;

	ifolder = br_prefs_mailfolders_folders->value();
	if (ifolder)
	{
		folder = br_prefs_mailfolders_folders->text (ifolder);

		WordList *F = PREFS_FCURRENTBOX->Get_collection ("folders")->Get_collection (folder)->Get_wordlist ("filters");
		char tmp[128];
		int i;

		switch (ch_prefs_filt_match->value())
		{
			case 0: F->Add ("7"); break;
			case 1: F->Add ("2"); break;
			case 2: F->Add ("Message-ID"); break;
			case 3: F->Add ("Subject"); break;
			case 4: F->Add ("From"); break;
			case 5: F->Add ("To"); break;
			case 6: F->Add ("Newsgroups"); break;
			case 7: F->Add ("Sender"); break;
			case 8: F->Add ("Reply-To"); break;
			case 9: F->Add ("Received"); break;
			case 10: F->Add ("Cc"); break;
			default: F->Add ("Subject"); break;
		}
		switch (ch_prefs_filt_type->value())
		{
			case 0: F->Add ("subs"); break;
			case 1: F->Add ("case"); break;
			case 2: F->Add ("glob"); break;
		}
		switch (ch_prefs_filt_action->value())
		{
			case 0: F->Add ("accept"); break;
			case 1: F->Add ("deny"); break;
			case 2: F->Add ("score"); break;
		}
		F->AddInt (0);
		F->Add (in_prefs_filt_string->value());

		br_prefs_filters->clear();

		for (i=0; i+4 < F->Count; i+=5)
		{
			sprintf (tmp, "%s\t%s", F->Get(i), F->Get(i+4));
			br_prefs_filters->add (tmp, NULL);
		}
		bt_prefs_filt_delete->deactivate();
	}
}

void cb_prefs_mailfolders_newsub (Fl_Button *b, void *v)
{
	if (PREFS_FCURRENTBOX)
	{
		if (PREFS_FCURRENTBOX->Get_wordlist ("folders")->Find ("Untitled") < 0)
		{
			PREFS_FCURRENTBOX->Get_collection ("folders")->Get_collection ("Untitled")->Set_char ("type","sub");
			br_prefs_mailfolders_folders->add ("Untitled", &pixmap_folder, NULL);
			br_prefs_mailfolders_folders->value (br_prefs_mailfolders_folders->size());
			br_prefs_mailfolders_folders->redraw();
			in_prefs_mailfolders_foldername->value ("Untitled");
			gr_prefs_mailfolders_folderset->activate();
			br_prefs_mailfolders_subfolders->activate();
			bt_prefs_mailfolders_subadd->activate();
		}
	}
}

void cb_prefs_mailfolders_sub_add (Fl_Button *b, void *v)
{
	char buf[256];
	int ifolder;
	char *folder;

	if (PREFS_FCURRENTBOX)
	{
		ifolder = br_prefs_mailfolders_folders->value();
		if (ifolder)
		{
			folder = br_prefs_mailfolders_folders->text (ifolder);
			sprintf (buf, "%s:Untitled", folder);
			if (PREFS_FCURRENTBOX->Get_wordlist ("folders")->Find (buf) < 0)
			{
				PREFS_FCURRENTBOX->Get_collection ("folders")->Get_collection (buf);
				
				br_prefs_mailfolders_subfolders->add ("Untitled", &pixmap_mbox, NULL);
				br_prefs_mailfolders_subfolders->value (br_prefs_mailfolders_subfolders->size());
				br_prefs_mailfolders_subfolders->redraw();
				in_prefs_mailfolders_subname->value ("Untitled");
				bt_prefs_mailfolders_subadd->activate();
				gr_prefs_mailfolders_subset->activate();
			}
		}
	}
}

void cb_prefs_mailfolders_sub_del (Fl_Button *b, void *v)
{
	char buf[256];
	int ifolder;
	char *folder;
	int isub;
	char *sub;
	if (PREFS_FCURRENTBOX)
	{
		ifolder = br_prefs_mailfolders_folders->value();
		if (ifolder)
		{
			folder = br_prefs_mailfolders_folders->text (ifolder);
			isub = br_prefs_mailfolders_subfolders->value();
			if (isub)
			{
				sub = br_prefs_mailfolders_subfolders->text (isub);
				br_prefs_mailfolders_subfolders->remove (isub);
				br_prefs_mailfolders_subfolders->redraw();
				sprintf (buf, "%s:%s", folder, sub);
				PREFS_FCURRENTBOX->Get_collection ("folders")->Delete (buf);
				gr_prefs_mailfolders_subset->deactivate();
			}
			//gr_prefs_mailfolders_folderset->deactivate();
		}
	}
}

void cb_prefs_mailfolders_subname (Fl_Input *in, void *v)
{
	char *newval;
	int ifolder;
	char *folder;
	int isub;
	char *sub;
	char *val = in->value();
	char buf[256], buf2[256];
	
	if (strlen (val) > 1)
	{
		ifolder = br_prefs_mailfolders_folders->value();
		if (ifolder)
		{
			folder = br_prefs_mailfolders_folders->text (ifolder);
			isub = br_prefs_mailfolders_subfolders->value();
			if (isub)
			{
				sub = br_prefs_mailfolders_subfolders->text (isub);
				sprintf (buf, "%s:%s", folder, sub);
				sprintf (buf2, "%s:%s", folder, val);
				PREFS_FCURRENTBOX->Get_collection ("folders")->Rename (buf, buf2);
				br_prefs_mailfolders_subfolders->text (isub, val);
			}	
		}
	}
}

void cb_prefs_mailfolders_sub (Fl_Iconbrowser *b, void *v)
{
	in_prefs_mailfolders_subname->value (b->text (b->value()));
			gr_prefs_mailfolders_subset->activate();
			gr_prefs_filters->activate();
}

void cb_prefs_mailfolders_foldername (Fl_Input *in, void *v)
{
	char *newval;
	int ifolder;
	char *folder;
	char *val = in->value();
	if (strlen (val) > 1)
	{
		ifolder = br_prefs_mailfolders_folders->value();
		if (ifolder)
		{
			folder = br_prefs_mailfolders_folders->text (ifolder);
			WordList *F = PREFS_FCURRENTBOX->Get_wordlist ("folders");
			if (F->Find (val) < 0)
			{
				PREFS_FCURRENTBOX->Get_collection ("folders")->Rename (folder, val);
			}
			br_prefs_mailfolders_folders->text (ifolder, val);
		}
		else
		{
			gr_prefs_mailfolders_subset->deactivate();
			gr_prefs_filters->deactivate();
		}
	}
}

void cb_prefs_mailfolder_folder_add (Fl_Button *b, void *v)
{
	if (PREFS_FCURRENTBOX)
	{
		if (PREFS_FCURRENTBOX->Get_wordlist ("folders")->Find ("Untitled") < 0)
		{
			PREFS_FCURRENTBOX->Get_collection ("folders")->Get_collection ("Untitled");
			br_prefs_mailfolders_folders->add ("Untitled", &pixmap_mbox, NULL);
			br_prefs_mailfolders_folders->value (br_prefs_mailfolders_folders->size());
			br_prefs_mailfolders_folders->redraw();
			in_prefs_mailfolders_foldername->value ("Untitled");
			in_prefs_mailfolders_foldername->redraw();
			gr_prefs_mailfolders_folderset->activate();
			br_prefs_mailfolders_subfolders->deactivate();
			bt_prefs_mailfolders_subadd->deactivate();
			gr_prefs_mailfolders_subset->deactivate();
			gr_prefs_filters->activate();
			br_prefs_filters->clear();
			bt_prefs_filt_delete->deactivate();
		}
	}
}

void cb_prefs_mailfolder_folder_del (Fl_Button *b, void *v)
{
	char *newval;
	int ifolder;
	char *folder;
	ifolder = br_prefs_mailfolders_folders->value();
	if (ifolder)
	{
		folder = br_prefs_mailfolders_folders->text (ifolder);
		WordList *F = PREFS_FCURRENTBOX->Get_wordlist ("folders");
		if (F->Find (folder) >= 0)
		{
			PREFS_FCURRENTBOX->Get_collection ("folders")->Delete (folder);
		}
		br_prefs_mailfolders_folders->remove (ifolder);
		br_prefs_mailfolders_folders->redraw();
		gr_prefs_mailfolders_folderset->deactivate();
		gr_prefs_filters->deactivate();
	}
}

void cb_prefs_protocol_mysql (Fl_Input *i, void *v)
{
	if (PREFS_CURRENTBOX)
	{
		PREFS_CURRENTBOX->Set_char ("host", in_prefs_protocol_mysql_host->value());
		PREFS_CURRENTBOX->Set_char ("user", in_prefs_protocol_mysql_user->value());
		PREFS_CURRENTBOX->Set_char ("pass", in_prefs_protocol_mysql_pass->value());
		PREFS_CURRENTBOX->Set_char ("database", in_prefs_protocol_mysql_db->value());
		PREFS_CURRENTBOX->Set_char ("table", in_prefs_protocol_mysql_tab->value());
	}
}

void cb_prefs_protocol_pop3 (Fl_Input *i, void *v)
{
	if (PREFS_CURRENTBOX)
	{
		PREFS_CURRENTBOX->Set_char ("host", in_prefs_protocol_pop3_host->value());
		PREFS_CURRENTBOX->Set_char ("user", in_prefs_protocol_pop3_user->value());
		PREFS_CURRENTBOX->Set_char ("pass", in_prefs_protocol_pop3_pass->value());
	}
}

void cb_prefs_protocol_nntp (Fl_Input *i, void *v)
{
	if (PREFS_CURRENTBOX)
	{
		PREFS_CURRENTBOX->Set_char ("host", in_prefs_protocol_nntp_host->value());
		PREFS_CURRENTBOX->Set_char ("user", in_prefs_protocol_nntp_user->value());
		PREFS_CURRENTBOX->Set_char ("pass", in_prefs_protocol_nntp_pass->value());
	}
}

void cb_prefs_mailbox_delete (Fl_Button *b, void *v)
{
	int val;
	char *nam;
	
	if (val=br_prefs_mailboxes->value())
	{
		nam = br_prefs_mailboxes->text(val);
		LPREFERENCES.Get_collection("postoffice")->Get_collection("mailboxes")->Delete(nam);
		PREFS_CURRENTBOX = NULL;
		gr_mailboxes_set->deactivate();
		br_prefs_mailboxes->remove(val);
		br_prefs_mailfolders_mailboxes->remove(val);
	}
}

void cb_prefs_mailbox_add (Fl_Button *b, void *v)
{
	int i;
	
	for (i=1;i<=br_prefs_mailboxes->size();++i)
	{
		if (strcasecmp (br_prefs_mailboxes->text(i), "untitled") == 0) return;
	}
	br_prefs_mailboxes->add ("Untitled", &pixmap_folder, NULL);
	br_prefs_mailfolders_mailboxes->add ("Untitled", &pixmap_folder, NULL);
	br_prefs_mailboxes->value (br_prefs_mailboxes->size());
	in_prefs_mailboxname->value ("Untitled");
	PREFS_CURRENTBOX = LPREFERENCES.Get_collection("postoffice")->Get_collection("mailboxes")->Get_collection("Untitled");
	PREFS_CURRENTBOX->Set_char ("host","host.domain.com");
	cb_prefs_mailboxes(br_prefs_mailboxes, (void *) NULL);
}

void cb_prefs_mailboxname (Fl_Input *in, void *v)
{
	int val;
	int i;
	char *vl;
	int ln;
	
	if ((ln = strlen (vl = in_prefs_mailboxname->value())) > 1)
	{
		for (i=0;i<ln;++i) if (vl[i]==' ') vl[i] = '_'; // strip whitespaces
		for (i=1;i<=br_prefs_mailboxes->size();++i)
		{
			if (strcasecmp (br_prefs_mailboxes->text(i), vl) == 0) return;
		}
		if (val = br_prefs_mailboxes->value())
		{
			//PREFS_CURRENTBOX = PREFERENCES.Get_collection("postoffice")->Get_collection("mailboxes")->Get_collection(br_prefs_mailboxes->text(val));
			LPREFERENCES.Get_collection ("postoffice")->Get_collection("mailboxes")->Rename (br_prefs_mailboxes->text(val), in_prefs_mailboxname->value());
			br_prefs_mailboxes->text (val, in_prefs_mailboxname->value());
			br_prefs_mailfolders_mailboxes->text (val, in_prefs_mailboxname->value());
		}
	}
}

void cb_prefs_mailbox_flags (Fl_Choice *b, void *v)
{
	if (PREFS_CURRENTBOX)
	{
		PREFS_CURRENTBOX->Set_int ("collection",ch_prefs_collection->value());
		PREFS_CURRENTBOX->Set_int ("msgpolicy",ch_prefs_msgpolicy->value());
		PREFS_CURRENTBOX->Set_int ("rplypolicy",ch_prefs_rplypolicy->value());
		PREFS_CURRENTBOX->Set_int ("msgarchive",ch_prefs_msgarchive->value());
		//PREFS_CURRENTBOX->Set_int ("archtrash",ch_prefs_archtrash->value());
	}
}

void cb_prefs_protocol (Fl_Choice *c, void *v)
{
	func_view_protocol();
}

void cb_prefs_window (Fl_Window *w, void *v)
{
	int i;

	win_prefs->hide();
}

void cb_prefs_identities (Fl_Iconbrowser *b, void *v)
{
	WordList	*X;
	int		  val, i;
	char		*nam;
	
	if (val = br_prefs_identities->value())
	{
		PREFS_CURRENTIDENT = (Var *) NULL;
		nam = br_prefs_identities->text (val);
		X = LPREFERENCES.Get_collection ("postoffice")->Get_wordlist("identities");
		for (i=0; i<X->Count;++i)
		{
			// printf ("comparing %s with %s\n", LPREFERENCES.Get_char_tree (4, "postoffice", "identities", X->Get(i), "shortname"), nam);
			if (strcasecmp (LPREFERENCES.Get_char_tree (4, "postoffice", "identities", X->Get(i), "shortname"), nam) == 0)
			{
				PREFS_CURRENTIDENT = LPREFERENCES.Get_collection ("postoffice")->Get_collection ("identities")->Get_collection (X->Get(i));
				i = X->Count;
			}
		}
		if (PREFS_CURRENTIDENT)
		{
			in_prefs_identityname->value (nam);
			gr_identities_set->activate();
			in_prefs_id_realname->value (PREFS_CURRENTIDENT->Get_char ("realname"));
			in_prefs_id_email->value (PREFS_CURRENTIDENT->Get_char ("mailfrom"));
			in_prefs_id_replyto->value (PREFS_CURRENTIDENT->Get_char ("replyto"));
			in_prefs_id_org->value (PREFS_CURRENTIDENT->Get_char ("organization"));
		}
		else gr_identities_set->deactivate();
	}
	else gr_identities_set->deactivate();
}

void cb_prefs_identity_add (Fl_Button *b, void *v)
{
	int i;
	char buf[24];
		
	for (i=1;i<=br_prefs_identities->size();++i)
	{
		if (strcasecmp (br_prefs_identities->text(i), "untitled") == 0) return;
	}
	
	sprintf (buf, "%d", time (NULL));
	
	br_prefs_identities->add ("Untitled", &pixmap_identity, NULL);
	br_prefs_identities->value (br_prefs_identities->size());
	in_prefs_identityname->value ("Untitled");
	PREFS_CURRENTIDENT = LPREFERENCES.Get_collection("postoffice")->Get_collection("identities")->Get_collection(buf);
	PREFS_CURRENTIDENT->Set_char ("shortname","Untitled");
	cb_prefs_identities(br_prefs_identities, (void *) NULL);
}

void cb_prefs_identityname (Fl_Input *in, void *v)
{
	int val;
	int i;
	char *vl;
	char *vl2;
	
	if (strlen (vl = in_prefs_identityname->value()) > 1)
	{
		for (i=1;i<=br_prefs_identities->size();++i)
		{
			if (strcasecmp (br_prefs_identities->text(i), vl) == 0) return;
		}
		if (val = br_prefs_identities->value())
		{
			vl2 = br_prefs_identities->text (val);
			//PREFS_CURRENTBOX = PREFERENCES.Get_collection("postoffice")->Get_collection("mailboxes")->Get_collection(br_prefs_mailboxes->text(val));
			WordList *X = LPREFERENCES.Get_collection ("postoffice")->Get_wordlist("identities");
			for (i=0;i<X->Count;++i)
			{
				if (strcmp (vl2, LPREFERENCES.Get_collection ("postoffice")->Get_collection ("identities")->Get_collection (X->Get(i))->Get_char ("shortname")) == 0)
				{
					LPREFERENCES.Get_collection ("postoffice")->Get_collection ("identities")->Get_collection (X->Get(i))->Set_char ("shortname", vl); i = X->Count;
				}
			}
			LPREFERENCES.Get_collection ("postoffice")->Get_collection("identities")->Rename (br_prefs_mailboxes->text(val), in_prefs_mailboxname->value());
			br_prefs_identities->text (val, in_prefs_identityname->value());
		}
	}
}

void cb_prefs_identity_del (Fl_Button *b, void *v)
{
	int vl;
	char *val;
	int i;
	
	if (vl = br_prefs_identities->value())
	{
		val = br_prefs_identities->text (vl);
		WordList *X = LPREFERENCES.Get_collection ("postoffice")->Get_wordlist("identities");
		for (i=0;i<X->Count;++i)
		{
			if (strcmp (val, LPREFERENCES.Get_collection ("postoffice")->Get_collection ("identities")->Get_collection (X->Get(i))->Get_char ("shortname")) == 0)
			{
				LPREFERENCES.Get_collection ("postoffice")->Get_collection ("identities")->Delete (X->Get(i)); i = X->Count;
			}
		}
		br_prefs_identities->remove (vl);
	}
}

void cb_prefs_identity_fields (Fl_Input *b, void *v)
{
	if (PREFS_CURRENTIDENT)
	{
		PREFS_CURRENTIDENT->Set_char ("realname", in_prefs_id_realname->value());
		PREFS_CURRENTIDENT->Set_char ("mailfrom", in_prefs_id_email->value());
		PREFS_CURRENTIDENT->Set_char ("replyto", in_prefs_id_replyto->value());
		PREFS_CURRENTIDENT->Set_char ("organization", in_prefs_id_org->value());
	}
}

void cb_prefs_smtpserver (Fl_Input *w, void *v)
{
	//in_prefs_smtpserver->value (LPREFERENCES.Get_char_tree ("postoffice/network/smtp"));
	LPREFERENCES.Get_collection ("postoffice")->Get_collection ("network")->Set_char ("smtp", in_prefs_smtpserver->value());
}

void cb_prefs_apply (Fl_Button *b, void *v)
{
// 	PREFERENCES.CopyFrom (&LPREFERENCES);
// 	Var *VBoxes = PREFERENCES.Get_collection ("postoffice")->Get_collection ("mailboxes");
// 	WordList *MBoxes = VBoxes->GatherNames();
// 
// 	int i=0;
// 
// 	while (MailBoxList[i])
// 	{
// 		delete (MailBoxList[i++]);
// 	}
// 	
// 	for (i=0;i<MBoxes->Count;++i)
// 	{
// 		printf ("[startup] Creating Mailbox: %s\n", MBoxes->Get(i));
// 		MailBoxList[i] = new MailBox (PIPE, MBoxes->Get(i));
// 	}
// 	MailBoxList[i] = (MailBox *) NULL;
// 	delete (MBoxes);
// 	update_tree (br_folderlist);
	cb_prefs_save (b,v);
}

void cb_prefs_cancel (Fl_Button *b, void *v)
{
		win_prefs->hide();
}

void cb_prefs_save (Fl_Button *b, void *v)
{
	char buf[256];
	int i;

	win_prefs->hide();
	Fl::wait(0.01);
	
	Fl_Scroll *scr = current_boxlist;
	
	sprintf (buf, "%s/.postoffice/resource.rc.bak", getenv ("HOME"));
	PREFERENCES.Save (buf);
	sprintf (buf, "%s/.postoffice/resource.rc", getenv ("HOME"));
	LPREFERENCES.Save (buf);
	
	br_folderindex->clear();
	br_message->clear();

	i = scr->children()-1;
	while (i>=2)
	{
		scr->remove(scr->child(i-2));
		i--;
	}
	
	i=0;
	
	while (MailBoxList[i])
	{
		MailBoxList[i]->SaveMailBox();
		MailBoxList[i]->Quit();
		delete (MailBoxList[i]);
		++i;
	}

	PREFERENCES.Clear();
	PREFERENCES.CopyFrom (&LPREFERENCES);

	Var *VBoxes = PREFERENCES.Get_collection ("postoffice")->Get_collection ("mailboxes");
	WordList *MBoxes = VBoxes->GatherNames();
	
	for (i=0;i<MBoxes->Count;++i)
	{
		MailBoxList[i] = new MailBox (PIPE, MBoxes->Get(i));
	}
	MailBoxList[i] = (MailBox *) NULL;
	delete (MBoxes);
	
	update_tree (current_boxlist);
	
	//execve (__ARGV[0], __ARGC, __ARGV);
	//cb_prefs_apply (b, v);	
}
