#define ST_STARTUP 	0x01
#define ST_SENTHELO 0x02
#define ST_SENTFROM 0x03
#define ST_SENTRCPT 0x04
#define ST_SENTDATA 0x05
#define ST_SENTMAIL 0x06
#define ST_QUIT     0x07

#include "socketclasses.h"
#include "var.h"
#include "wordlist.h"
#include <time.h>
#include <FL/Fl.H>

extern Var PREFERENCES;

char *send_message_smtp (WordList *HdrNames, WordList *HdrValues, char *mailfrom, WordList *Recipients, char *message)
{
	char			 buffer[256];
	int				 state;
	int				 res;
	int				 successfully_sent;
	int				 i;
	int				 errors = 0;
	time_t			 ti;
	char			*error = NULL;
	char			*ct;
	WordList		 WD;

	tzset();
	
	state = ST_STARTUP;
	successfully_sent = 0;
	
	Connection *C = new Connection (1);
	C->Open (PREFERENCES.Get_char_tree ("postoffice/network/smtp"),25);
	
	while ((res = C->Handle(buffer, 255, 0, 500, 0)) >= 0)
	{
		Fl::wait(0.5);
		printf ("[smtp] state=%02x\n", state);
		if (res>0)
		{
			printf ("[smtp] %s\n", buffer);
			switch (state)
			{
				case ST_STARTUP:
				
						C->SendF (10, "HELO toolazytolookup.com\n");
						state = ST_SENTHELO;
					break;
				
				case ST_SENTHELO:
				
					buffer[3] = 0; if (strcmp (buffer, "250") == 0)
					{
						C->SendF (10, "MAIL FROM: %s\n", mailfrom);
						state = ST_SENTFROM;
					}
					else
					{
						error = new char[strlen(buffer+4)+1];
						strcpy (error, buffer+4);
						state = ST_QUIT;
					}
					break;

				case ST_SENTFROM:
				
					buffer[3] = 0; if (strcmp (buffer, "250") == 0)
					{
						C->SendF (10, "RCPT TO: %s\n", Recipients->Get(0));
						Recipients->Delete (0);
						if (Recipients->Count == 0)
							state = ST_SENTRCPT;
					}
					else
					{
						error = new char[strlen(buffer+4)+1];
						strcpy (error, buffer+4);
						state = ST_QUIT;
					}
					break;

				case ST_SENTRCPT:
				
					buffer[3] = 0; if (strcmp (buffer, "250") == 0)
					{
						C->SendF (10, "DATA\n");
						state = ST_SENTDATA;
					}
					else
					{
						error = new char[strlen(buffer+4)+1];
						strcpy (error, buffer+4);
						state = ST_QUIT;
					}
					break;
					
				case ST_SENTDATA:
				
					ti = time (NULL);
					ct = ctime (&ti);
				
					buffer[3] = 0; if (strcmp (buffer, "354") == 0)
					{
						for (i=0;i<HdrNames->Count;++i)
						{
							C->SendF (10, "%s: %s\n", HdrNames->Get(i), HdrValues->Get(i));
						}
						WD.MakeGeneric (ct, ' ');
						C->SendF (10, "Date: %s, %s %s %s %s %s\n", WD.Get(0), WD.Get(2), WD.Get(1), WD.Get(4), WD.Get(3), tzname[1]);
						C->SendF (10, "X-Mailer: PostOffice 1.0\n\n");
						printf ("[smtp] ---> message<---\n");
						puts (message);
						printf ("\n[smtp] --> end of message <--\n");
						C->Send (message, 10);
						C->SendF (10, "\n.\n");
						state = ST_SENTMAIL;
					}
					else
					{
						error = new char[strlen(buffer+4)+1];
						strcpy (error, buffer+4);
						state = ST_QUIT;
					}
					break;
					
				case ST_SENTMAIL:
				
					buffer[3] = 0; if (strcmp (buffer, "250") != 0)
					{
						error = new char[strlen(buffer+4)+1];
						strcpy (error, buffer+4);
					}
					C->SendF (10, "QUIT\n");
					state = ST_QUIT;
					break;
					
				case ST_QUIT:
					C->Close();
					break;
			}
		}
		else
		{
			Fl::wait (1.0);
			if (++errors > 96)
			{
				error = new char[96];
				sprintf (error, "Connection to %s timed out", C->Address);
				delete (C);
				return (error);
			}
		}
	}
	delete (C);
	return (error);
}
