// generated by Fast Light User Interface Designer (fluid) version 1.00

#include "multiple.h"
void AddToWindowMenu(Fl_MultiEditor *editor, long sessid, const char *menuname, Fl_Menu *menu);
void RemoveFromWindowMenu(Fl_MultiEditor *editor, long sessid, Fl_Menu_* menu, Fl_Menu *winmenu);
static Fl_Menu_Item *WindowMenu = NULL;
Fl_Menu_Item *FindWindowMenu(const Fl_Menu *menu);
bool CloseSession(Fl_Menu_ *menu, Fl_Menu *WindowMenu, Fl_MultiEditor *ed);
bool ExitOK(Fl_Menu_ *menu, Fl_Menu *WinMenu, Fl_MultiEditor *ed);
void ChangeWindowMenu(Fl_MultiEditor *editor, const char *oldname, Fl_Menu_* mainmenu, Fl_Menu* winmenu);
static char *Win23Dummy = "........................................................................................................................................";
// Win32Dummy is a kludge for Win32 release compile, see the readme

Fl_Window *myWindow=(Fl_Window *)0;

static Fl_MultiEditor *myEditor=(Fl_MultiEditor *)0;

Fl_Menu_Bar *MenuBar=(Fl_Menu_Bar *)0;

static void cb_New(Fl_Menu_*, Fl_MultiEditor* v) {
  long sessid = v->NewSession();
WindowMenu = FindWindowMenu(MenuBar->menu());
if(sessid >= 0)
   AddToWindowMenu(v, sessid, "&Window", WindowMenu);
myWindow->label(v->SessionName());
}

static void cb_Open(Fl_Menu_*, Fl_MultiEditor* v) {
  WindowMenu = FindWindowMenu(MenuBar->menu());
char *fn;
fn = fl_file_chooser("Open File", NULL, NULL);
if(fn)
{
      long sessid = v->NewSession(fn);
      AddToWindowMenu(v, sessid, "&Window", WindowMenu);
      myWindow->label(v->SessionName());
};
}

static void cb_Insert(Fl_Menu_*, Fl_MultiEditor* v) {
  char *fn;
fn = fl_file_chooser("Open File", NULL, NULL);
if(fn)
   {
       FILE *file = fopen(fn, "r");
       if(file)
          {
               v->LoadFrom(file);
               fclose(file);
          }
   };
}

static void cb_Save(Fl_Menu_* o, Fl_MultiEditor* v) {
  WindowMenu = FindWindowMenu(MenuBar->menu());
const char *fn = v->CurrentFileName();
if (!fn || (!fn[0]))
{
   fn = fl_file_chooser("Save As", NULL, NULL);
   if(fn)
   {
      wString oldname = v->SessionName();
      v->SaveCurrent(fn);
      ChangeWindowMenu(v, oldname.Get(), o, WindowMenu);
   }
}
else
   v->SaveCurrent(fn);
}

static void cb_Save1(Fl_Menu_* o, Fl_MultiEditor * v) {
  WindowMenu = FindWindowMenu(MenuBar->menu());
const char *fn = fl_file_chooser("Save As", NULL, NULL);
if(fn)
{
   wString oldname = v->SessionName();
   v->SaveCurrent(fn);
   ChangeWindowMenu(v, oldname.Get(), o, WindowMenu);
};
}

static void cb_Close(Fl_Menu_* o, Fl_MultiEditor* v) {
  WindowMenu = FindWindowMenu(MenuBar->menu());
CloseSession(o, WindowMenu, v);
}

static void cb_E(Fl_Menu_* o, Fl_MultiEditor* v) {
  WindowMenu = FindWindowMenu(MenuBar->menu());
if(ExitOK((Fl_Menu_*)o, WindowMenu, v))
   myWindow->hide();
}

static void cb_Cu(Fl_Menu_*, Fl_MultiEditor* v) {
  v->Cut();
}

static void cb_Copy(Fl_Menu_*, Fl_MultiEditor* v) {
  v->Copy();
}

static void cb_Paste(Fl_Menu_*, Fl_MultiEditor* v) {
  v->Paste();
}

static void cb_Toggle(Fl_Menu_*, Fl_MultiEditor * v) {
  v->readonly(!v->readonly());
}

static void cb_Find(Fl_Menu_*, Fl_MultiEditor* v) {
  v->Find();
}

static void cb_Find1(Fl_Menu_*, Fl_MultiEditor* v) {
  v->FindNext();
}

static void cb_Replace(Fl_Menu_*, Fl_MultiEditor* v) {
  v->Replace();
}

static void cb_Next(Fl_Menu_*, Fl_MultiEditor* v) {
  v->NextSession();
myWindow->label(v->SessionName());
}

static void cb_Previous(Fl_Menu_*, Fl_MultiEditor* v) {
  v->PreviousSession();
myWindow->label(v->SessionName());
}

Fl_Menu_Item menu_MenuBar[] = {
 {"&File", 0,  0, 0, 64, 0, 0, 12, 0},
 {"&New", 0,  (Fl_Callback*)cb_New, (void*)(NULL), 0, 0, 0, 12, 0},
 {"&Open", 0,  (Fl_Callback*)cb_Open, (void*)(NULL), 0, 0, 0, 12, 0},
 {"&Insert File", 0,  (Fl_Callback*)cb_Insert, (void*)(NULL), 128, 0, 0, 12, 0},
 {"&Save", 0,  (Fl_Callback*)cb_Save, (void*)(NULL), 0, 0, 0, 12, 0},
 {"Save &As", 0,  (Fl_Callback*)cb_Save1, (void*)(NULL), 0, 0, 0, 12, 0},
 {"&Close", 0,  (Fl_Callback*)cb_Close, (void*)(NULL), 128, 0, 0, 12, 0},
 {"E&xit", 0,  (Fl_Callback*)cb_E, (void*)(NULL), 0, 0, 0, 12, 0},
 {0},
 {"&Edit", 0,  0, 0, 64, 0, 0, 12, 0},
 {"Cu&t", 0,  (Fl_Callback*)cb_Cu, (void*)(NULL), 0, 0, 0, 12, 0},
 {"&Copy", 0,  (Fl_Callback*)cb_Copy, (void*)(NULL), 0, 0, 0, 12, 0},
 {"&Paste", 0,  (Fl_Callback*)cb_Paste, (void*)(NULL), 0, 0, 0, 12, 0},
 {"Toggle &Read-Only", 0,  (Fl_Callback*)cb_Toggle, 0, 0, 0, 0, 12, 0},
 {0},
 {"&Search", 0,  0, 0, 64, 0, 0, 12, 0},
 {"&Find", 0x40066,  (Fl_Callback*)cb_Find, (void*)(NULL), 0, 0, 0, 12, 0},
 {"Find &Again", 0xffc0,  (Fl_Callback*)cb_Find1, (void*)(NULL), 128, 0, 0, 12, 0},
 {"&Replace", 0,  (Fl_Callback*)cb_Replace, (void*)(NULL), 0, 0, 0, 12, 0},
 {0},
 {"&Window", 0,  0, 0, 64, 0, 0, 12, 0},
 {"&Next", 0,  (Fl_Callback*)cb_Next, (void*)(NULL), 0, 0, 0, 12, 0},
 {"&Previous", 0,  (Fl_Callback*)cb_Previous, (void*)(NULL), 0, 0, 0, 12, 0},
 {0},
 {0}
};

int main(int argc, char **argv) {
  Fl_Window* w;
  { Fl_Window* o = myWindow = new Fl_Window(306, 240, "Test Window");
    w = o;
    { Fl_MultiEditor* o = myEditor = new Fl_MultiEditor(3, 23, 299, 212);
      o->box(FL_DOWN_BOX);
      o->color(7);
      o->selection_color(14);
      Fl_Group::current()->resizable(o);
      o->textfont(FL_HELVETICA);
      o->textsize(14);
    }
    { Fl_Menu_Bar* o = MenuBar = new Fl_Menu_Bar(-2, -1, 310, 21);
      o->box(FL_THIN_UP_BOX);
      o->labelsize(12);
      o->textsize(12);
      { Fl_Menu_Item* o = &menu_MenuBar[1];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[2];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[3];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[4];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[5];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[6];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[7];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[10];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[11];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[12];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[13];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[16];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[17];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[18];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[21];
        o->user_data((void *)myEditor);
      }
      { Fl_Menu_Item* o = &menu_MenuBar[22];
        o->user_data((void *)myEditor);
      }
      o->menu(menu_MenuBar);
    }
    o->end();
  }
  WindowMenu = FindWindowMenu(MenuBar->menu());
long sessid = myEditor->Session();
AddToWindowMenu(myEditor, sessid, "&Window", WindowMenu);
myWindow->label(myEditor->SessionName());
  w->show(argc, argv);
  return Fl::run();
}
